Dancer::Error(3pm)

NAME
Dancer::Error - class for representing fatal errors

VERSION
version 1.3522

SYNOPSIS
    # taken from send_file:
    use Dancer::Error;

    my $error = Dancer::Error->new(
        code    => 404,
        message => "No such file: `$path'"
    );

    $error->render;

DESCRIPTION
With Dancer::Error you can throw reasonable-looking errors to the user instead of crashing the application and filling up the logs.

This is usually used in debugging environments, and it's what Dancer uses as well under debugging to catch errors and show them on screen.

ATTRIBUTES

  code
The code that caused the error.

This is only an attribute getter, you'll have to set it at "new".

  title
The title of the error page.

This is only an attribute getter, you'll have to set it at "new".

  message
The message of the error page.

This is only an attribute getter, you'll have to set it at "new".

  exception
The exception that caused the error. If the error was not caused by an exception, returns undef. Exceptions are usually objects that inherit from Dancer::Exception.

This is only an attribute getter, you'll have to set it at "new".

METHODS/SUBROUTINES

  new
Create a new Dancer::Error object.

title

The title of the error page.

type

What type of error this is.

code

The code that caused the error.

message

The message that will appear to the user.

exception

The exception that will be useable by the rendering.

  backtrace
Create a backtrace of the code where the error is caused.

This method tries to find out where the error appeared according to the actual error message (using the "message" attribute) and tries to parse it (supporting the regular/default Perl warning or error pattern and the Devel::SimpleTrace output) and then returns an error-highlighted "message".

  tabulate
Small subroutine to help output nicer.

  dumper
This uses Data::Dumper to create nice content output with a few predefined options.

  render
Renders a response using Dancer::Response.

  environment
A main function to render environment information: the caller (using "get_caller"), the settings and environment (using "dumper") and more.

  get_caller
Creates a stack trace of callers.

  _censor
An internal method that tries to censor out content which should be protected.

"dumper" calls this method to censor things like passwords and such.

  _html_encode
Internal method to encode entities that are illegal in (X)HTML. We output as UTF-8, so no need to encode all non-ASCII characters or use a module. FIXME : this is not true any more, output can be any charset. Need fixing.

AUTHOR
Dancer Core Developers

COPYRIGHT AND LICENSE
This software is copyright (c) 2010 by Alexis Sukrieh.

This is free software; you can redistribute it and/or modify it under the same terms as the Perl 5 programming language system itself.